<template>
	<view class="container">
		<!-- 顶部logo and 搜索 start-->
		<view class="status_bar"></view>
		<view class="top-bg"></view>
		<view class="top-search flex">
			<view class="search-box flex" @click="clickSearch()">
				<image class="search" src="../../static/icon/search-w.png" mode=""></image>
				<view class="search-font">输入关键词搜索</view>
			</view>
		</view>
		<!-- 顶部logo and 搜索 end-->
		<view class="jg" style="background-color: #fff;"></view>
		<!-- 轮播图 start -->
		<swiper class="top-swiper" autoplay="true" duration="400" interval="5000" @change="swiperChange">
			<swiper-item v-for="(item, index) in carouselList" :key="index" class="carousel-item"
				@click="bannerNavToUrl(item)">
				<image :src="item.pic" />
			</swiper-item>
		</swiper>
		<!-- 轮播图 end -->
		<!-- 积分 -->
		
			<view class="common-wrap" v-if="list.length > 0">
				<view class="tit">
					<view class="cate">
						特惠折扣 <text>限量抢购</text>
					</view>
					<view class="more" @click="navto('/pages/index/yuyue?state=1')">
						查看更多<image src="../../static/index/in-go.png" mode=""></image>
					</view>
				</view>
				<view class="goods-wrap flex-start">
					<view class="goods" v-for="good in list"
						@click="navto('/pages/product/product?id=' + good.id)">
						<image :src="good.image" mode="" class="goods-img"></image>
						<view class="goods-tit clamp">
							{{good.store_name}}
						</view>
						<view class="goods-price" >
							<text class="new-price">
								<text class="rmb">￥</text>{{good.price*1}}
							</text>
						</view>
					</view>
				</view>
			</view>
		<view class="in-banner">
			<image v-for="item in inBanner" :src="'../../static/img/in-b'+item.state + '.png'" mode="widthFix" @click="navto('/pages/index/yuyue?state=' + item.state)"></image>
		</view>
		<view class="in-btm">
			<image src="../../static/img/in-ed.png" mode=""></image>
		</view>
	</view>
</template>

<script>
	import {
		loadIndexs,
	} from '@/api/index.js';
	import {
		groomList,
		getProducts
	} from '@/api/product.js';
	import {
		saveUrl,
		interceptor
	} from '@/utils/loginUtils';
	import {
		mapState,
		mapMutations
	} from 'vuex';
	// #ifdef H5
	import {
		weixindata,
		shareLoad
	} from '@/utils/wxAuthorized';
	// #endif
	import {
		getCategoryList
	} from '@/api/product.js';
	export default {
		data() {
			return {
				list: [],
				inBanner: [
					// {
					// 	state:1,
					// 	tit: '洗衣'
					// },
					{
						state:2,
						tit: '家政'
					},
					{
						state:3,
						tit: '维修'
					}
				],
				kzList: [],
				cunList: [],
				bastList: [],
				cateList: [],
				carouselList: [], //轮播列表
				navList: [{
						state: 6,
						path: '/pages/product/classify?type=6',
						tit: '礼包商品',
						logo: '',
						list: [],
						qdata: {
							limit: 3,
							page: 1
						},
						loaded: false
					},
					{
						state: 5,
						path: '/pages/product/classify?type=5',
						tit: '积分兑换区',
						logo: '',
						list: [],
						qdata: {
							limit: 3,
							page: 1
						},
						loaded: false
					},
				],
				showList: false
			};
		},
		computed: {
			...mapState('user', ['hasLogin', 'userInfo'])
		},
		onShareAppMessage(options) {
			// 设置菜单中的转发按钮触发转发事件时的转发内容
			let pages = getCurrentPages(); //获取加载的页面
			let currentPage = pages[pages.length - 1]; //获取当前页面的对象
			let url = currentPage.route; //当前页面url
			let item = currentPage.options; //如果要获取url中所带的参数可以查看options
			let shareObj = {}
			if (this.userInfo.uid) {
				shareObj = {
					title: this.userInfo.nickname + '邀请您加入7131', // 默认是小程序的名称(可以写slogan等)
					path: url + '?scene=' + this.userInfo.uid, // 默认是当前页面，必须是以‘/’开头的完整路径
					imageUrl: '',
					success: function(res) {
						// 转发成功之后的回调
						if (res.errMsg == 'shareAppMessage:ok') {}
					},
					fail: function() {
						// 转发失败之后的回调
						if (res.errMsg == 'shareAppMessage:fail cancel') {
							// 用户取消转发
						} else if (res.errMsg == 'shareAppMessage:fail') {
							// 转发失败，其中 detail message 为详细失败信息
						}
					}
				};
			} else {
				shareObj = {
					// title: '', // 默认是小程序的名称(可以写slogan等)
					path: url, // 默认是当前页面，必须是以‘/’开头的完整路径
					imageUrl: '',
					success: function(res) {
						// 转发成功之后的回调
						if (res.errMsg == 'shareAppMessage:ok') {}
					},
					fail: function() {
						// 转发失败之后的回调
						if (res.errMsg == 'shareAppMessage:fail cancel') {
							// 用户取消转发
						} else if (res.errMsg == 'shareAppMessage:fail') {
							// 转发失败，其中 detail message 为详细失败信息
						}
					}
				};
			}

			return shareObj;
		},
		onReachBottom() {},
		onLoad: function(option) {
			// #ifdef MP
			if (option.scene) {
				// 存储小程序邀请人
				uni.setStorage({
					key: 'spread_code',
					data: option.scene
				});
			}
			// #endif
			// #ifdef H5
			if (option.spread) {
				// 存储小程序邀请人
				uni.setStorage({
					key: 'spread',
					data: option.spread
				});
			}
			// #endif
		},
		onShow: function() {
			// this.getGoodList()
			this.loadData();
			// this.getnavbar();
			this.getProducts()
		},
		onHide() {},
		methods: {
			swiperChange() {
				
			},
			showW() {
				// if(this.cateList.length > 4 && )
				if(this.cateList.length < 4) {
					return '33.3%'
				}else if(this.cateList.length >=4 && this.cateList.length % 4 == 0 ) {
					console.log('zhe25')
					return '25%'
				}else {
					console.log('zhe20')
					return '20%'
				}
			},
			getProducts() {
				getProducts({
					is_housekeeping:0,
					is_maintenance:0
				}).then(res => {
					this.list = res.data
					console.log(this.cunList,'cunList')
				})
				//
				getProducts({
					sid: 56
				}).then(res => {
					this.kzList = res.data
				})
			},
			getnavbar() {
				let obj = this;
				getCategoryList({})
					.then(({
						data
					}) => {
						this.cateList = data.map((re) => {
							if (re.children.length > 0) {
								const ar = re.children[0];
								ar.path = '/pages/product/list?&fid=' + re.id + 'sid=' + re.id + '&tid=' + ar
									.id
								return ar
							} else {
								re.path = '/pages/product/list?&sid=' + re.id
								return re
							}
						});
						console.log();
						console.log(data, '123456');
					})
					.catch(err => {
						console.log(err);
					});
			},
			// gogogo(item) {
			// 	if (!item.path) {
			// 		uni.navigateTo({
			// 			url: '/pages/index/dkf'
			// 		})
			// 	}
			// 	if (item.path == 'kf') {
			// 		this.$refs.popupkf.open()
			// 	} else {

			// 		uni.navigateTo({
			// 			url: item.path + '&tit=' + item.tit,
			// 			fail() {
			// 				uni.navigateTo({
			// 					url: item.path,
			// 					fail() {
			// 						uni.switchTab({
			// 							url: item.path,
			// 						})
			// 					}
			// 				})
			// 			}
			// 		})
			// 	}
			// },
			getGoodList() {
				// let obj = this
				// let lb = obj.navList[0];
				// let jf = obj.navList[1];
				// // let vip = obj.navList[2];
				// groomList(lb.qdata, lb.state).then(res => {
				// 	lb.list = res.data.list
				// })
				// groomList(jf.qdata, jf.state).then(res => {
				// 	jf.list = res.data.list
				// })
			},
			navto(url, type = 0) {
				if (type == 1) {
					if (!this.hasLogin) {
						// 保存地址
						saveUrl();
						// 登录拦截
						interceptor();
					} else {
						uni.navigateTo({
							url,
							fail() {
								uni.switchTab({
									url
								})
							}
						})
					}
				} else {
					
					// #ifdef MP-WEIXIN
					// if(url)
					if(url.charAt(0)=='#') {
						return wx.navigateToMiniProgram({
							    shortLink:url,
							    //develop开发版；trial体验版；release正式版
							    envVersion: 'release', 
							    success(res) {
							      // 打开成功
							      console.log("跳转小程序成功！",res);
							    } 
							})
					}else {
						uni.navigateTo({
							url,
							fail() {
								uni.switchTab({
									url
								})
							}
						})
					}
					// #endif
					// #ifndef MP
					uni.navigateTo({
						url,
						fail() {
							uni.switchTab({
								url
							})
						}
					})
					// #endif
				}

			},
			// navTo(url) {
			// 	if (url == '') {
			// 		this.$api.msg('暂未开通，敬请期待');
			// 	} else {
			// 		this.navto(url)
			// 	}
			// },
			// 點擊搜索框
			clickSearch() {
				uni.navigateTo({
					url: '/pages/product/search'
				});
			},
			// 监听图片加载完成
			onImageError(key, index) {
				this[key][index].image = '/static/error/errorImage.jpg';
			},
			// 请求载入数据
			async loadData() {
				loadIndexs({})
					.then(({
						data
					}) => {
						let goods = data.info;
						this.carouselList = data.banner;
						this.bastList = data.likeInfo;
						this.cateList = data.menus;
						let yy_model = +data.yy_model;
						if (yy_model == 0) {
							console.log(yy_model);
							this.showList = true;
						}
						uni.setStorageSync('yydm', data.yy_model);
						uni.stopPullDownRefresh();
					})
					.catch(e => {
						uni.stopPullDownRefresh();
					});
			},
			// 轮播图跳转
			bannerNavToUrl(item) {
				// #ifdef H5
				// console.log(item.wap_url.indexOf('http'), 'banner');
				if (item.wap_url.indexOf('http') >= 0) {
					window.location.href = item.wap_url;
				}
				// uni.navigateTo({
				// 	url: '/pages/zero/order'
				// })
				// #endif
				//测试数据没有写id，用title代替
				uni.navigateTo({
					url: item.wap_url
				});
			},
			comfirm(text) {
				// console.log(text);
				const result = this.uniCopy(text);
				if (result === false) {
					uni.showToast({
						title: '不支持'
					});
				} else {
					uni.showToast({
						title: '复制成功',
						icon: 'none'
					});
				}
				this.$refs.popupkf.close();
			},
			uniCopy(content) {
				/**
				 * 小程序端 和 app端的复制逻辑
				 */
				//#ifndef H5
				uni.setClipboardData({
					data: content,
					success: function() {
						// console.log('success');
						return true;
					}
				});
				//#endif

				/**
				 * H5端的复制逻辑
				 */
				// #ifdef H5
				if (!document.queryCommandSupported('copy')) {
					//为了兼容有些浏览器 queryCommandSupported 的判断
					// 不支持
					return false;
				}
				let textarea = document.createElement('textarea');
				textarea.value = content;
				textarea.readOnly = 'readOnly';
				document.body.appendChild(textarea);
				textarea.select(); // 选择对象
				textarea.setSelectionRange(0, content.length); //核心
				let result = document.execCommand('copy'); // 执行浏览器复制命令
				textarea.remove();
				return result;
				// #endif
			},
			// 打开客服
			openKf() {
				this.$refs.popupkf.open();
			},
			// 关闭客服
			cancel() {
				this.$refs.popupkf.close();
			},
		}
	};
</script>

<style lang="scss">
	image {
		vertical-align: middle;
	}

	page {
		min-height: 100%;
		height: auto;
		background-color: #fff;
	}

	// 顶部搜索
	.top-search {
		height: 80rpx;
		padding: 0 20rpx;
		position: relative;

		.top-logo {
			width: 50rpx;
			// height: 50rpx;
			margin-right: 10rpx;

			image {
				width: 48rpx;
			}

		}

		.search-box {
			justify-content: center;
			width: 698rpx;
			height: 60rpx;
			background: rgba(255, 255, 255, 0.5);
			color: #fff;
			// box-shadow: 0px 10rpx 20rpx 0px rgba(4, 114, 69, 0.22);
			border-radius: 30rpx;

			.search {
				width: 34rpx;
				height: 34rpx;
			}

			.search-font {
				margin-left: 14rpx;
				font-size: 28rpx;
				font-weight: 500;
			}
		}
	}

	// 顶部轮播图
	.top-swiper {
		background-color: #fff;
		width: 690rpx;
		height: 320rpx;
		margin: auto;

		.carousel-item {
			image {
				width: 100%;
				height: 100%;
				border-radius: 20rpx;
			}
		}

		// margin: 20rpx 0 0;

	}

	.swiper-btm {
		height: 60rpx;
		width: 750rpx;
		background-color: #fff;
		margin-bottom: 20rpx;
		font-size: 26rpx;
		font-weight: 500;
		color: #333333;

		.btm-item {
			flex-grow: 1;
			justify-content: center;

			image {
				width: 25rpx;
				height: 25rpx;
				margin-right: 14rpx;
			}
		}
	}

	.jg {
		height: 20rpx;
		background: #F8F8F8;
	}

	// 分类
	.cate-section {
		justify-content: flex-start;
		background-color: #fff;
		padding: 0 20rpx 30rpx;
		flex-wrap: wrap;

		.cate-item {
			padding-top: 30rpx;
			flex-grow: 0;
			width: 20%;
			flex-direction: column;
			text-align: center;
			align-items: center;
			justify-content: center;

			.img-wrapper {
				width: 123rpx;
				height: 123rpx;
				border-radius: 20rpx;
				position: relative;

				image {
					width: 100%;
					height: 100%;
					position: absolute;
					left: 50%;
					top: 50%;
					transform: translate(-50%, -50%);
				}
			}

			.item-title {
				margin-top: 15rpx;
				font-size: 26rpx;
				font-weight: 500;
			}
		}
	}

	.hot-wrap {
		background-color: #fff;
		padding-top: 20rpx;

		.tit {
			display: block;
			height: 40rpx;
			margin: 20rpx auto 40rpx;
		}

		.hot-list {
			// margin-top: 38rpx;
			width: 100%;
			display: flex;
			flex-wrap: wrap;
			padding: 0 20rpx 30rpx;
			justify-content: space-between;

			.hotgoods-item {
				width: 345rpx;
				background-color: #ffffff;
				border-radius: 12rpx;
				box-shadow: 0 0 15rpx rgba(0, 0, 0, 0.2);
				margin-bottom: 15rpx;

				.image-wrapper {
					width: 345rpx;
					height: 345rpx;
					border-radius: 3px;
					overflow: hidden;
					position: relative;

					.image-bg {
						position: absolute;
						top: 0;
						left: 0;
						right: 0;
						bottom: 0;
						width: 100%;
						height: 100%;
						opacity: 1;
						border-radius: 12rpx 12rpx 0 0;
						z-index: 2;
					}

					.image {
						width: 100%;
						height: 100%;
						opacity: 1;
						border-radius: 12rpx 12rpx 0 0;
					}
				}

				.title {
					margin-top: 24rpx;
					padding: 0 20rpx;
					font-size: 32rpx;
					font-weight: 500;
					color: #333333;
				}

				.hot-price {
					display: flex;
					justify-content: flex-start;
					align-items: center;
					width: 100%;
					padding: 0 10rpx;
					// padding: 14rpx 0 30rpx;

					.hotPrice-box {
						padding: 2rpx 6rpx;

						background: linear-gradient(90deg, #c79a4c, #f9df7f);
						border-radius: 5rpx;
						text-align: center;
						line-height: 28rpx;
						font-size: 20rpx;
						font-family: Source Han Sans CN;
						font-weight: 400;
						color: #ffffff;
					}

					.price {
						margin-left: 10rpx;
						font-size: 36rpx;
						color: #ff0000;
						font-weight: 500;
						display: flex;
						width: 100%;
						justify-content: flex-start;
						align-items: center;

						.jf {
							font-size: 20rpx;
						}

						.give-jf {
							display: inline-block;
							padding: 8rpx;

							background: linear-gradient(90deg, #FF834D, #FF2600);
							border-radius: 12rpx 0px 12rpx 0px;

							font-size: 22rpx;
							font-weight: 500;
							color: #FFFFFF;
							margin-left: 22rpx;
						}

						.ot-pirce {
							margin-left: 7rpx;
							font-size: 26rpx;
							font-weight: 500;
							text-decoration: line-through;
							color: #999999;
							align-self: flex-end;
						}

					}

					.yuanPrice {
						margin-left: 10rpx;
						font-size: 20rpx;
						font-family: PingFang SC;
						font-weight: 500;
						text-decoration: line-through;
						color: #999999;
					}

					.cart-icon {
						image {
							width: 44rpx;
							height: 44rpx;
						}
					}
				}
			}
		}
	}

	.popup-box {
		width: 522rpx;
		height: 605rpx;
		background-color: #ffffff;
		border-radius: 20rpx;
		position: relative;

		.img {
			position: relative;
			top: -56rpx;
			left: 0;
			width: 522rpx;
			height: 132rpx;
			display: flex;
			justify-content: center;

			image {
				border-radius: 20rpx 20rpx 0 0;
				width: 450rpx;
				height: 132rpx;
			}
		}

		.mian {
			margin-top: -44rpx;
			display: flex;
			flex-direction: column;
			align-items: center;
			// padding: 32rpx 32rpx;
			background-color: #ffffff;
			border-radius: 0 0 20rpx 20rpx;
			text-align: center;

			.delivery {
				font-size: 40rpx;
				color: #333333;
				display: flex;
				align-items: center;
				flex-direction: column;

				image {
					margin-top: 48rpx;
					width: 172rpx;
					height: 160rpx;
				}
			}

			.nocancel {
				font-size: 32rpx;
				color: #333333;
				margin-top: 14rpx;
			}

			.comfirm-box {
				margin-top: 52rpx;
				display: flex;
				// margin-bottom: 32rpx;

				// justify-content: space-around;
				.cancel {
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					border: 1px solid #dcc786;
					border-radius: 38rpx;

					font-size: 32rpx;
					color: #605128;
				}

				.comfirm {
					margin-left: 32rpx;
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					background: linear-gradient(-90deg, #d1ba77 0%, #f7e8ad 100%);
					border-radius: 38px;
					font-size: 32rpx;
					color: #605128;
				}
			}
		}
	}

	.top-bg {
		height: 450rpx;
		//#f53934
		background-image: linear-gradient(to bottom, $base-color, #fff);
		position: absolute;
		top: 0;
		width: 100%;
	}

	.gsjs {
		width: 100%;
	}

	.status_bar {
		height: var(--status-bar-height);
		width: 100%;
	}

	.common-wrap {
		background-color: #fff;
		padding: 25rpx 35rpx 25rpx 0rpx;

		.tit {
			display: flex;
			align-items: center;
			padding-left: 30rpx;

			.logo {
				width: 37rpx;
				height: 36rpx;
			}

			.cate {
				font-size: 32rpx;
				font-weight: bold;
				flex-grow: 1;
				padding-left: 10rpx;
				position: relative;
				z-index: 2;
				text {
					font-size: 24rpx;
					padding-left: 10rpx;
				}
				&::before {
					z-index: 1;
					content: '';
					width: 70rpx;
					height: 12rpx;
					background: linear-gradient(93deg, red 0%, #FEABB6 47%, #FFFAFA 100%);
					position: absolute;
					bottom: 0;
					left: 10rpx;
					opacity: 0.5;
				}
			}

			.more {
				font-size: 24rpx;
				font-weight: 500;
				color: #9A9A9A;

				image {
					display: inline-block;
					margin-left: 10rpx;
					width: 10rpx;
					height: 20rpx;
					vertical-align: middle;
				}
			}
		}

		.goods-wrap {
			flex-wrap: wrap;

			.goods {
				width: 207rpx;
				margin-top: 30rpx;
				margin-left: 30rpx;

				// &:nth-child(2n){
				// 	margin:30rpx 30rpx 0 30rpx;
				// }
				.goods-img {
					width: 207rpx;
					height: 207rpx;
					border-radius: 20rpx;
					background-color: #9A9A9A;
				}

				.goods-tit {
					font-size: 26rpx;
					font-weight: 500;
					padding: 15rpx 0 8rpx;
				}

				.goods-price {
					font-size: 30rpx;
					font-weight: 500;
					color: #FF6F0F;

					.ot-pirce {
						padding-left: 15rpx;
						font-size: 20rpx;
						font-weight: 500;
						text-decoration: line-through;
						color: #9A9A9A;
					}

					image {
						width: 22rpx;
						height: 24rpx;
						margin-right: 6rpx;
					}

					.vip-price {
						display: inline-block;
						border-radius: 5rpx;
						font-size: 24rpx;
						padding: 6rpx 5rpx 5rpx 9rpx;
						margin-left: 8rpx;
						border: 1px solid #FF6F0F;
					}
				}

			}
		}
	}

	.rmb {
		font-size: 24rpx;
	}
	.in-banner {
		background-color: #ffffff;
		padding: 20rpx 0;
		image {
			width: 704rpx;
			// height: ;
			display: block;
			margin:20rpx auto;
		}
	}
	.in-btm {
		padding-bottom: 30rpx;
		background-color: #fff;
		image {
			width: 700rpx;
			height: 141rpx;
			display: block;
			margin: auto;
		}
	}
</style>